--[[	PhantomPlates CastBar Module
	by SDPhantom
	https://www.wowinterface.com/forums/member.php?u=34145
	https://www.curseforge.com/members/sdphantomgamer/projects	]]
--------------------------------------------------------------------------

--------------------------
--[[	Namespace	]]
--------------------------
local AddOn=select(2,...);
if AddOn.ClientVersionMajor>=2 then return; end--	Vanilla only

AddOn.CastBar=true;--	Signal to the rest of the addon that the CastBar module is loaded

------------------
--[[	Hooks	]]
------------------
local CastBars={};

AddOn.OnNamePlateCreated:AddCallback(function(_,base)
	local unitframe=base.UnitFrame;
	if not (unitframe:IsForbidden() or unitframe.CastBar) then
		unitframe.CastBar=CreateFrame("StatusBar",nil,unitframe,"SmallCastingBarFrameTemplate");
		unitframe.CastBar:SetPoint("TOP",unitframe.healthBar,"BOTTOM",17,-9);
		unitframe.CastBar:SetSize(102,10);
		unitframe.CastBar:Hide();

--		Copy/Paste from TBC+
		unitframe.CastBar:HookScript("OnShow",function(self)
			self.Border:ClearAllPoints();
			self.Border:SetPoint("TOPLEFT",-22,20);
			self.Border:SetTexture("Interface/Tooltips/Nameplate-Border-Castbar");
			self.Border:SetSize(128,32);
			self.Border:SetTexCoord(0,1,0,1);

			self.Icon:SetSize(14,14);
			self.Icon:SetPoint("RIGHT",self,"LEFT",-3,1);

			self.Flash:SetTexCoord(0,0,0,0);
			self.Text:Hide();

			if(self.notInterruptible) then
				self.Icon:SetPoint("RIGHT",self,"LEFT",-5,2);

				self.BorderShield:ClearAllPoints();
				self.BorderShield:SetWidth(25);
				self.BorderShield:SetHeight(45);
				self.BorderShield:SetPoint("TOPLEFT",-23,18);
				self.BorderShield:SetPoint("TOPRIGHT",17,17);
			end
		end);

		CastingBarFrame_SetUnit(unitframe.CastBar,"player",false,false);
	end
end);

----------------------------------
--[[	Options Defaults	]]
----------------------------------
AddOn.Options.CastBar_Enabled=true;

--------------------------
--[[	Options Layout	]]
--------------------------
local SubPanel=AddOn.Options_CreateSubPanel(1);
AddOn.CastBar_OptionsSubPanel=SubPanel;
SubPanel:SetHeight(32);

local ShowCastBarButton=CreateFrame("CheckButton",nil,SubPanel,"UICheckButtonTemplate");
ShowCastBarButton:SetPoint("TOPLEFT",4,0);
ShowCastBarButton.Text:SetText(AddOn.Localization.OptionsSetting_CastBar_Enabled);

--------------------------
--[[	Options Setup	]]
--------------------------
AddOn.Options_RegisterControl("CastBar_Enabled",ShowCastBarButton
	,nil
	,ShowCastBarButton.SetChecked
	,ShowCastBarButton.GetChecked
	,"OnClick"
);

AddOn.Options_HookOption("CastBar_Enabled",function(_,_,val)
	for unitframe,bar in pairs(CastBars) do
		bar.showCastbar=val;

--		.casting and .channeling are true/nil
		local shouldshow=(val and (bar.casting or bar.channeling or false));
		if bar.IsShown()~=shouldshow then bar:SetShown(shouldshow); end
	end
end);
