--[[	PhantomPlates Dispatcher Library
	by SDPhantom
	https://www.wowinterface.com/forums/member.php?u=34145
	https://www.curseforge.com/members/sdphantomgamer/projects	]]
--------------------------------------------------------------------------

--------------------------
--[[	Namespace	]]
--------------------------
local AddOn=select(2,...);

----------------------------------
--[[	Dispatcher Metatable	]]
----------------------------------
local DispatcherMeta={__index={}};

local DispatcherEnclosures=setmetatable({},{
	__mode="kv";
	__index=function(t,k)
		local function dispatcher(...) return k(...); end
		t[k]=dispatcher; return dispatcher;
	end;
});

function DispatcherMeta.__index:AddCallback(func,index)
	local pos; index,pos=index and math.max(1,math.min(index,#self+1)),tIndexOf(self,func);
	if index and index~=pos then
		if pos then table.remove(self,pos); end
		table.insert(self,index,func);
	elseif not pos then table.insert(self,func); end
end

function DispatcherMeta.__index:RemoveCallback(func)
	local index=tIndexOf(self,func);
	if index then table.remove(self,index); end
end

function DispatcherMeta.__index:WipeCallbacks() return table.wipe(self); end

function DispatcherMeta.__index:FireCallbacks(...)
	for _,func in ipairs(self) do xpcall(func,CallErrorHandler,...); end
end

function DispatcherMeta.__index:EncloseDispatcher() return DispatcherEnclosures[self]; end

DispatcherMeta.__call=DispatcherMeta.__index.FireCallbacks;

----------------------------------
--[[	Dispatcher Objects	]]
----------------------------------
function AddOn.CreateDispatcher() return setmetatable({},DispatcherMeta); end
function AddOn.IsDispatcher(obj) return type(obj)=="table" and getmetatable(obj)==DispatcherMeta; end
