--[[	PhantomPlates Personal Resource Bar Module
	by SDPhantom
	https://www.wowinterface.com/forums/member.php?u=34145
	https://www.curseforge.com/members/sdphantomgamer/projects	]]
--------------------------------------------------------------------------

--------------------------
--[[	Namespace	]]
--------------------------
local AddOn=select(2,...);
if AddOn.ClientVersionMajor<3 then return; end--	Only available for Wrath+

----------------------------------
--[[	Helper Functions	]]
----------------------------------
local function CastBarIsActive(bar)
	return (bar.casting or bar.channeling) or false;--	CastingBarFrame_OnEvent() sets these as true/nil
end

----------------------------------
--[[	Personal Resource Bar	]]
----------------------------------
local PersonalResourceBar=CreateFrame("Frame");
AddOn.PersonalResourceBar=PersonalResourceBar;

local VisibilityLock;
local Frame_SetShown,Frame_Show,Frame_Hide=PersonalResourceBar.SetShown,PersonalResourceBar.Show,PersonalResourceBar.Hide;
function PersonalResourceBar:SetShown(show)
	if self.UnitFrame then
		VisibilityLock=show; if show==nil then
			return Frame_SetShown(self,not CastBarIsActive(self.UnitFrame.CastBar));
		else return Frame_SetShown(self,show); end
	else return Frame_Hide(self); end
end

function PersonalResourceBar:Show() VisibilityLock=true; if self.UnitFrame then return Frame_Show(self); end end
function PersonalResourceBar:Hide() VisibilityLock=false; return Frame_Hide(self); end

----------------------------------
--[[	Event Handlers & Hooks	]]
----------------------------------
local HookedCastBars={};
local function CastBar_OnEvent(self)
	if (PersonalResourceBar.UnitFrame and self==PersonalResourceBar.UnitFrame.CastBar) and VisibilityLock==nil then
		Frame_SetShown(PersonalResourceBar,not CastBarIsActive(self));
	end
end

AddOn.OnNamePlateAdded:AddCallback(function(baseframe,unit)
	if not baseframe:IsForbidden() and unit=="player" then
		local unitframe=baseframe.UnitFrame;
		PersonalResourceBar:SetParent(unitframe);
		PersonalResourceBar:SetPoint("TOP",unitframe,"BOTTOM");

		PersonalResourceBar.UnitFrame=unitframe;
		if VisibilityLock==nil then
			Frame_SetShown(PersonalResourceBar,not CastBarIsActive(unitframe.CastBar));
			if not HookedCastBars[unitframe.CastBar] then
				unitframe.CastBar:HookScript("OnEvent",CastBar_OnEvent);
				HookedCastBars[unitframe.CastBar]=true;
			end
		else Frame_SetShown(PersonalResourceBar,VisibilityLock); end
	end
end);

AddOn.OnNamePlateRemoved:AddCallback(function(baseframe)
	if baseframe.UnitFrame==PersonalResourceBar.UnitFrame then	
		PersonalResourceBar.UnitFrame=nil;
		Frame_Hide(PersonalResourceBar);
	end
end);
