--[[	PhantomPlates Personal Resource Bar - Rune Bar Module
	by SDPhantom
	https://www.wowinterface.com/forums/member.php?u=34145
	https://www.curseforge.com/members/sdphantomgamer/projects	]]
--------------------------------------------------------------------------

if select(2,UnitClass("player"))~="DEATHKNIGHT" then return; end--	Required Class

--------------------------
--[[	Namespace	]]
--------------------------
local AddOn=select(2,...);
if not AddOn.PersonalResourceBar then return; end--	Required Module

--------------------------
--[[	Constants	]]
--------------------------
local RuneTextureMap={
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Blood";
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Frost";
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Unholy";
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Death";
};

local RuneRemap={1,2,5,6,3,4};--	RuneID > Position

----------------------------------
--[[	Helper Functions	]]
----------------------------------
local function RuneBar_UpdateRuneCooldown(self,runeid)
	local start,duration,ready=GetRuneCooldown(runeid);
	local runeframe=self.Runes[RuneRemap[runeid]];
	if (start or 0)>0 and (duration or 0)>0 then
		CooldownFrame_Set(runeframe.Cooldown,start,duration,not ready,true);
	end
end

local function RuneBar_UpdateRuneType(self,runeid)
	local runetype=GetRuneType(runeid);
	local runeframe=self.Runes[RuneRemap[runeid]];
	if runetype then
		runeframe.Rune:SetTexture(RuneTextureMap[runetype]);
		runeframe:Show();
	else
		runeframe:Hide();
	end
end

------------------
--[[	Layout	]]
------------------
local RuneBar=AddOn.PersonalResourceBar;
RuneBar:SetSize(123,18);

RuneBar:SetScale(0.8);
RuneBar.Runes={};

for i=1,6 do
	local rune=CreateFrame("Frame",nil,RuneBar);
	rune:SetPoint("TOPLEFT",(i-1)*21,0);
	rune:SetSize(18,18);

	rune:SetFrameLevel(RuneBar:GetFrameLevel());

	rune.Cooldown=CreateFrame("Cooldown",nil,rune,"CooldownFrameTemplate");
	rune.Cooldown:SetPoint("CENTER");
	rune.Cooldown:SetSize(15,15);

	rune.Cooldown:SetReverse(false);
	rune.Cooldown:SetDrawEdge(true);
	rune.Cooldown:SetUseCircularEdge(true);
	rune.Cooldown:SetDrawBling(false);

	rune.Rune=rune:CreateTexture(nil,"BACKGROUND");
	rune.Rune:SetTexture("Interface\PlayerFrame\UI-PlayerFrame-Deathknight-Blood");
	rune.Rune:SetPoint("CENTER");
	rune.Rune:SetSize(24,24);

	local border=rune:CreateTexture(nil,"BORDER");
	border:SetTexture("Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Ring");
	border:SetVertexColor(0.6,0.6,0.6);
	border:SetPoint("CENTER");
	border:SetSize(24,24);

--[[
	rune.Shine=rune:CreateTexture(nil,"ARTWORK");
	rune.Shine:SetTexture("Interface\\ComboFrame\\ComboPoint");
	rune.Shine:SetBlendMode("ADD");
	rune.Shine:SetTexCoord(0.5625,1,0,1);
	rune.Shine:SetPoint("CENTER");
	rune.Shine:SetSize(60,35);
	rune.Shine:Hide();
--]]

	RuneBar.Runes[i]=rune;
end

--------------------------
--[[	Script Handlers	]]
--------------------------
RuneBar:RegisterEvent("PLAYER_ENTERING_WORLD");
RuneBar:RegisterEvent("RUNE_POWER_UPDATE");
RuneBar:RegisterEvent("RUNE_TYPE_UPDATE");
RuneBar:SetScript("OnEvent",function(self,event,...)
	if event=="PLAYER_ENTERING_WORLD" then
		for i=1,#self.Runes do
			RuneBar_UpdateRuneCooldown(self,i);
			RuneBar_UpdateRuneType(self,i);
		end
	elseif event=="RUNE_POWER_UPDATE" then
		RuneBar_UpdateRuneCooldown(self,(...));
	elseif event=="RUNE_TYPE_UPDATE" then
		RuneBar_UpdateRuneType(self,(...));
	end
end);
